;;HACK
(define-syntax-rule (define-module- name args ...)
  (cond-expand
   (guile-3
    (define-module name
      #:declarative? #f
      args ...))
   (guile
    (define-module name args ...))))


(define-module- (logic guile-log prolog util)
  #:use-module (logic guile-log)
  #:use-module (logic guile-log prolog error)
  #:replace (member append length length_ repeat))


(<define> (member x l)
  (<match> (#:mode + #:name member) (l)
    ((y . l)
     (<or>
      (<=> x y)
      (member x l)))
    (_ <fail>)))

(define (mk-len do)
  (<define> (length ll n)
    (let ((ll (<lookup> ll))
	  (n  (<lookup> n)))
      (if (<var?> ll)
	  (if (integer? n)
	      (<recur> lp ((i 0) (l ll))
	        (if (eq? i n)
		    (<=> l ())
		    (<<match>> (#:mode + #:name length) (l)
		      ((_ . l)
		       (lp (+ i 1) l)))))
	      (type_error "integer" n))
	  (<recur> lp ((i 0) (l ll))
   	    (<<match>> (#:mode - #:name length) (l)
	      ((_ . l)
	       (lp (+ i 1) l))
	      (()	       
	       (<cut> (<=> n i)))
	      (_
	       (if do
		   (<cut> (<=> n i))
		   (type_error 'list ll))))))))
  length)

(define length  (mk-len #f))
(define length_ (mk-len #t))

(define append 
  (<case-lambda>
   ((a b)
    (append2 a b))
   ((a b c)
    (<match> (#:mode + #:name append) (a c)
      (()      ,b      <cc>)
      ((x . a) (x . c) (append a b c))
      (_        _      (<cut> <fail>))))))

(<define> (append2 a b)
  (<recur> lp ((res '()) (a a))
     (<match> (#:mode - #:name append2) (a)
       ((x . l)
	(<var> (y)
          (append res x y)
	  (lp y l)))
       (()
	(<cut> (<=> b res))))))

(<define> (repeat) (<or> <cc> (repeat)))
   
