;;HACK
(define-syntax-rule (define-module- name args ...)
  (cond-expand
   (guile-3
    (define-module name
      #:declarative? #f
      args ...))
   (guile
    (define-module name args ...))))


(define-module- (logic guile-log prolog conversion)
  #:pure
  #:use-module (logic guile-log prolog directives)
  #:use-module (logic guile-log prolog names)
  #:use-module ((guile) #:select ((floor . scm-floor) (ceiling  . scm-ceil)
                                  (round . scm-round) (truncate . scm-truncate)
                                  (sin   . scm-sin  ) (cos      . scm-cos)
                                  (atan  . scm-atan ) (log      . scm-log)
                                  (exp   . scm-exp  ) (sqrt     . scm-sqrt)
                                  define inexact->exact exact->inexact))
  #:replace (floor ceiling round truncate sin cos atan exp log))

(define (floor    x)  (inexact->exact (scm-floor    (is-a-num? x))))
(define (ceiling  x)  (inexact->exact (scm-ceil     (is-a-num? x))))
(define (round    x)  (inexact->exact (scm-round    (is-a-num? x))))
(define (truncate x)  (inexact->exact (scm-truncate (is-a-num? x))))

(define (sin      x)  (exact->inexact (scm-sin      (is-a-num? x))))
(define (cos      x)  (exact->inexact (scm-cos      (is-a-num? x))))
(define (atan     x)  (exact->inexact (scm-atan     (is-a-num? x))))
(define (log      x)  (exact->inexact (scm-log      (is-a-num? x))))
(define (exp      x)  (exact->inexact (scm-exp      (is-a-num? x))))
(define (sqrt     x)  (exact->inexact (scm-sqrt     (is-a-num? x))))
